"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __esm = (fn, res) => function __init() {
  return fn && (res = (0, fn[__getOwnPropNames(fn)[0]])(fn = 0)), res;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// ../../node_modules/viem/_esm/utils/data/isHex.js
function isHex(value, { strict = true } = {}) {
  if (!value)
    return false;
  if (typeof value !== "string")
    return false;
  return strict ? /^0x[0-9a-fA-F]*$/.test(value) : value.startsWith("0x");
}
var init_isHex = __esm({
  "../../node_modules/viem/_esm/utils/data/isHex.js"() {
    "use strict";
  }
});

// ../../node_modules/viem/_esm/utils/data/size.js
function size(value) {
  if (isHex(value, { strict: false }))
    return Math.ceil((value.length - 2) / 2);
  return value.length;
}
var init_size = __esm({
  "../../node_modules/viem/_esm/utils/data/size.js"() {
    "use strict";
    init_isHex();
  }
});

// ../../node_modules/viem/_esm/errors/version.js
var version;
var init_version = __esm({
  "../../node_modules/viem/_esm/errors/version.js"() {
    "use strict";
    version = "2.8.16";
  }
});

// ../../node_modules/viem/_esm/errors/utils.js
var getVersion;
var init_utils = __esm({
  "../../node_modules/viem/_esm/errors/utils.js"() {
    "use strict";
    init_version();
    getVersion = () => `viem@${version}`;
  }
});

// ../../node_modules/viem/_esm/errors/base.js
function walk(err, fn) {
  if (fn?.(err))
    return err;
  if (err && typeof err === "object" && "cause" in err)
    return walk(err.cause, fn);
  return fn ? null : err;
}
var BaseError;
var init_base = __esm({
  "../../node_modules/viem/_esm/errors/base.js"() {
    "use strict";
    init_utils();
    BaseError = class _BaseError extends Error {
      constructor(shortMessage, args = {}) {
        super();
        Object.defineProperty(this, "details", {
          enumerable: true,
          configurable: true,
          writable: true,
          value: void 0
        });
        Object.defineProperty(this, "docsPath", {
          enumerable: true,
          configurable: true,
          writable: true,
          value: void 0
        });
        Object.defineProperty(this, "metaMessages", {
          enumerable: true,
          configurable: true,
          writable: true,
          value: void 0
        });
        Object.defineProperty(this, "shortMessage", {
          enumerable: true,
          configurable: true,
          writable: true,
          value: void 0
        });
        Object.defineProperty(this, "name", {
          enumerable: true,
          configurable: true,
          writable: true,
          value: "ViemError"
        });
        Object.defineProperty(this, "version", {
          enumerable: true,
          configurable: true,
          writable: true,
          value: getVersion()
        });
        const details = args.cause instanceof _BaseError ? args.cause.details : args.cause?.message ? args.cause.message : args.details;
        const docsPath = args.cause instanceof _BaseError ? args.cause.docsPath || args.docsPath : args.docsPath;
        this.message = [
          shortMessage || "An error occurred.",
          "",
          ...args.metaMessages ? [...args.metaMessages, ""] : [],
          ...docsPath ? [
            `Docs: https://viem.sh${docsPath}${args.docsSlug ? `#${args.docsSlug}` : ""}`
          ] : [],
          ...details ? [`Details: ${details}`] : [],
          `Version: ${this.version}`
        ].join("\n");
        if (args.cause)
          this.cause = args.cause;
        this.details = details;
        this.docsPath = docsPath;
        this.metaMessages = args.metaMessages;
        this.shortMessage = shortMessage;
      }
      walk(fn) {
        return walk(this, fn);
      }
    };
  }
});

// ../../node_modules/viem/_esm/errors/data.js
var SizeExceedsPaddingSizeError;
var init_data = __esm({
  "../../node_modules/viem/_esm/errors/data.js"() {
    "use strict";
    init_base();
    SizeExceedsPaddingSizeError = class extends BaseError {
      constructor({ size: size2, targetSize, type }) {
        super(`${type.charAt(0).toUpperCase()}${type.slice(1).toLowerCase()} size (${size2}) exceeds padding size (${targetSize}).`);
        Object.defineProperty(this, "name", {
          enumerable: true,
          configurable: true,
          writable: true,
          value: "SizeExceedsPaddingSizeError"
        });
      }
    };
  }
});

// ../../node_modules/viem/_esm/utils/data/pad.js
function pad(hexOrBytes, { dir, size: size2 = 32 } = {}) {
  if (typeof hexOrBytes === "string")
    return padHex(hexOrBytes, { dir, size: size2 });
  return padBytes(hexOrBytes, { dir, size: size2 });
}
function padHex(hex_, { dir, size: size2 = 32 } = {}) {
  if (size2 === null)
    return hex_;
  const hex = hex_.replace("0x", "");
  if (hex.length > size2 * 2)
    throw new SizeExceedsPaddingSizeError({
      size: Math.ceil(hex.length / 2),
      targetSize: size2,
      type: "hex"
    });
  return `0x${hex[dir === "right" ? "padEnd" : "padStart"](size2 * 2, "0")}`;
}
function padBytes(bytes, { dir, size: size2 = 32 } = {}) {
  if (size2 === null)
    return bytes;
  if (bytes.length > size2)
    throw new SizeExceedsPaddingSizeError({
      size: bytes.length,
      targetSize: size2,
      type: "bytes"
    });
  const paddedBytes = new Uint8Array(size2);
  for (let i = 0; i < size2; i++) {
    const padEnd = dir === "right";
    paddedBytes[padEnd ? i : size2 - i - 1] = bytes[padEnd ? i : bytes.length - i - 1];
  }
  return paddedBytes;
}
var init_pad = __esm({
  "../../node_modules/viem/_esm/utils/data/pad.js"() {
    "use strict";
    init_data();
  }
});

// ../../node_modules/viem/_esm/errors/encoding.js
var SizeOverflowError;
var init_encoding = __esm({
  "../../node_modules/viem/_esm/errors/encoding.js"() {
    "use strict";
    init_base();
    SizeOverflowError = class extends BaseError {
      constructor({ givenSize, maxSize }) {
        super(`Size cannot exceed ${maxSize} bytes. Given size: ${givenSize} bytes.`);
        Object.defineProperty(this, "name", {
          enumerable: true,
          configurable: true,
          writable: true,
          value: "SizeOverflowError"
        });
      }
    };
  }
});

// ../../node_modules/viem/_esm/utils/encoding/fromHex.js
function assertSize(hexOrBytes, { size: size2 }) {
  if (size(hexOrBytes) > size2)
    throw new SizeOverflowError({
      givenSize: size(hexOrBytes),
      maxSize: size2
    });
}
var init_fromHex = __esm({
  "../../node_modules/viem/_esm/utils/encoding/fromHex.js"() {
    "use strict";
    init_encoding();
    init_size();
  }
});

// ../../node_modules/viem/_esm/utils/encoding/toBytes.js
function charCodeToBase16(char) {
  if (char >= charCodeMap.zero && char <= charCodeMap.nine)
    return char - charCodeMap.zero;
  if (char >= charCodeMap.A && char <= charCodeMap.F)
    return char - (charCodeMap.A - 10);
  if (char >= charCodeMap.a && char <= charCodeMap.f)
    return char - (charCodeMap.a - 10);
  return void 0;
}
function hexToBytes(hex_, opts = {}) {
  let hex = hex_;
  if (opts.size) {
    assertSize(hex, { size: opts.size });
    hex = pad(hex, { dir: "right", size: opts.size });
  }
  let hexString = hex.slice(2);
  if (hexString.length % 2)
    hexString = `0${hexString}`;
  const length = hexString.length / 2;
  const bytes = new Uint8Array(length);
  for (let index = 0, j = 0; index < length; index++) {
    const nibbleLeft = charCodeToBase16(hexString.charCodeAt(j++));
    const nibbleRight = charCodeToBase16(hexString.charCodeAt(j++));
    if (nibbleLeft === void 0 || nibbleRight === void 0) {
      throw new BaseError(`Invalid byte sequence ("${hexString[j - 2]}${hexString[j - 1]}" in "${hexString}").`);
    }
    bytes[index] = nibbleLeft * 16 + nibbleRight;
  }
  return bytes;
}
var charCodeMap;
var init_toBytes = __esm({
  "../../node_modules/viem/_esm/utils/encoding/toBytes.js"() {
    "use strict";
    init_base();
    init_pad();
    init_fromHex();
    charCodeMap = {
      zero: 48,
      nine: 57,
      A: 65,
      F: 70,
      a: 97,
      f: 102
    };
  }
});

// src/index.tsx
var src_exports = {};
__export(src_exports, {
  FrameUI: () => FrameUI,
  createFrameActionMessageWithSignerKey: () => createFrameActionMessageWithSignerKey,
  defaultTheme: () => defaultTheme,
  fallbackFrameContext: () => fallbackFrameContext,
  mockFarcasterSigner: () => mockFarcasterSigner,
  signFrameAction: () => signFrameAction,
  themeParams: () => themeParams
});
module.exports = __toCommonJS(src_exports);

// src/frame-ui.tsx
var import_react = __toESM(require("react"), 1);
var defaultTheme = {
  buttonBg: "#fff",
  buttonBorderColor: "#ccc",
  buttonHoverBg: "#efefef",
  buttonColor: "#444",
  buttonRadius: "4",
  bg: "#efefef"
};
var getThemeWithDefaults = (theme) => {
  return {
    ...defaultTheme,
    ...theme
  };
};
function FrameUI({ frameState, theme, FrameImage }) {
  const resolvedTheme = getThemeWithDefaults(theme ?? {});
  if (!frameState.homeframeUrl)
    return /* @__PURE__ */ import_react.default.createElement("div", null, "Missing frame url");
  if (frameState.error) {
    return /* @__PURE__ */ import_react.default.createElement("div", null, "Failed to load Frame");
  }
  if (frameState.homeframeUrl && !frameState.frame && !frameState.isLoading)
    return /* @__PURE__ */ import_react.default.createElement("div", null, "Failed to load Frame");
  if (!frameState.frame)
    return null;
  if (!frameState.isFrameValid)
    return /* @__PURE__ */ import_react.default.createElement("div", null, "Invalid frame");
  const ImageEl = FrameImage ? FrameImage : "img";
  return /* @__PURE__ */ import_react.default.createElement(
    "div",
    {
      style: { backgroundColor: resolvedTheme.bg },
      className: "flex flex-col w-full gap-2 rounded-br rounded-bl"
    },
    /* @__PURE__ */ import_react.default.createElement(
      ImageEl,
      {
        src: frameState.frame.image,
        alt: "Frame image",
        width: "100%",
        style: {
          filter: frameState.isLoading ? "blur(4px)" : void 0,
          borderTopLeftRadius: `${resolvedTheme.buttonRadius}px`,
          borderTopRightRadius: `${resolvedTheme.buttonRadius}px`,
          border: `1px solid ${resolvedTheme.buttonBorderColor}`,
          objectFit: "cover",
          width: "100%",
          aspectRatio: (frameState.frame.imageAspectRatio ?? "1.91:1") === "1:1" ? "1/1" : "1.91/1"
        }
      }
    ),
    frameState.frame.inputText && /* @__PURE__ */ import_react.default.createElement(
      "input",
      {
        className: "p-[6px] mx-2 border box-border",
        style: {
          borderRadius: `${resolvedTheme.buttonRadius}px`,
          borderColor: `${resolvedTheme.buttonBorderColor}`
        },
        value: frameState.inputText,
        type: "text",
        placeholder: frameState.frame.inputText,
        onChange: (e) => frameState.setInputText(e.target.value)
      }
    ),
    /* @__PURE__ */ import_react.default.createElement(
      "div",
      {
        style: {
          display: "flex",
          flexDirection: "row",
          gap: "8px"
        },
        className: "px-2 pb-2"
      },
      frameState.frame.buttons?.map(
        (frameButton, index) => /* @__PURE__ */ import_react.default.createElement(
          "button",
          {
            type: "button",
            disabled: !!frameState.isLoading,
            className: `p-2 ${frameState.isLoading ? "bg-gray-100" : ""} border text-sm text-gray-800 rounded`,
            style: {
              flex: "1 1 0px",
              // fixme: hover style
              backgroundColor: resolvedTheme.buttonBg,
              borderColor: resolvedTheme.buttonBorderColor,
              color: resolvedTheme.buttonColor,
              cursor: frameState.isLoading ? void 0 : "pointer"
            },
            onClick: () => frameState.onButtonPress(frameButton, index),
            key: index
          },
          frameButton.action === "mint" ? `\u2B17 ` : "",
          frameButton.label,
          frameButton.action === "tx" ? /* @__PURE__ */ import_react.default.createElement(
            "svg",
            {
              "aria-hidden": "true",
              focusable: "false",
              role: "img",
              viewBox: "0 0 16 16",
              className: "ml-1 mb-[2px] text-gray-400 inline-block select-none align-text-middle overflow-visible",
              width: "12",
              height: "12",
              fill: "currentColor"
            },
            /* @__PURE__ */ import_react.default.createElement("path", { d: "M9.504.43a1.516 1.516 0 0 1 2.437 1.713L10.415 5.5h2.123c1.57 0 2.346 1.909 1.22 3.004l-7.34 7.142a1.249 1.249 0 0 1-.871.354h-.302a1.25 1.25 0 0 1-1.157-1.723L5.633 10.5H3.462c-1.57 0-2.346-1.909-1.22-3.004L9.503.429Zm1.047 1.074L3.286 8.571A.25.25 0 0 0 3.462 9H6.75a.75.75 0 0 1 .694 1.034l-1.713 4.188 6.982-6.793A.25.25 0 0 0 12.538 7H9.25a.75.75 0 0 1-.683-1.06l2.008-4.418.003-.006a.036.036 0 0 0-.004-.009l-.006-.006-.008-.001c-.003 0-.006.002-.009.004Z" })
          ) : "",
          frameButton.action === "post_redirect" || frameButton.action === "link" ? ` \u2197` : ""
        )
      )
    )
  );
}

// src/types.ts
var themeParams = [
  "bg",
  "buttonColor",
  "buttonBg",
  "buttonBorderColor",
  "buttonRadius",
  "buttonHoverBg"
];

// src/farcaster/frames.tsx
var import_core = require("@farcaster/core");

// ../../node_modules/viem/_esm/index.js
init_toBytes();

// src/farcaster/frames.tsx
var signFrameAction = async ({
  buttonIndex,
  frameContext,
  frameButton,
  signer,
  target,
  inputText,
  state,
  transactionId,
  url
}) => {
  if (!signer?.fid) {
    throw new Error("Missing signer fid to sign message");
  }
  if (!signer.privateKey) {
    throw new Error("Missing Farcaster signer to sign message");
  }
  const { message, trustedBytes } = await createFrameActionMessageWithSignerKey(
    signer.privateKey,
    {
      fid: signer.fid,
      buttonIndex,
      castId: {
        fid: frameContext.castId.fid,
        hash: hexToBytes(frameContext.castId.hash)
      },
      state: state !== void 0 ? Buffer.from(state) : void 0,
      url: Buffer.from(url),
      // it seems the message in hubs actually requires a value here.
      inputText: inputText !== void 0 ? Buffer.from(inputText) : void 0,
      address: frameContext.connectedAddress !== void 0 ? hexToBytes(frameContext.connectedAddress) : void 0,
      transactionId: transactionId !== void 0 ? hexToBytes(transactionId) : void 0
    }
  );
  if (!message) {
    throw new Error("hub error");
  }
  const searchParams = new URLSearchParams({
    postType: transactionId ? "post" : frameButton?.action || "post",
    postUrl: target ?? ""
  });
  return {
    searchParams,
    body: {
      untrustedData: {
        fid: signer.fid,
        url,
        messageHash: `0x${Buffer.from(message.hash).toString("hex")}`,
        timestamp: message.data.timestamp,
        network: 1,
        buttonIndex: Number(message.data.frameActionBody.buttonIndex),
        castId: {
          fid: frameContext.castId.fid,
          hash: frameContext.castId.hash
        },
        inputText,
        address: frameContext.connectedAddress,
        transactionId
      },
      trustedData: {
        messageBytes: trustedBytes
      }
    }
  };
};
async function createFrameActionMessageWithSignerKey(signerKey, {
  fid,
  url,
  buttonIndex,
  castId,
  inputText,
  state,
  address,
  transactionId
}) {
  const signer = new import_core.NobleEd25519Signer(Buffer.from(signerKey.slice(2), "hex"));
  const messageDataOptions = {
    fid,
    network: import_core.FarcasterNetwork.MAINNET
  };
  const message = await (0, import_core.makeFrameAction)(
    import_core.FrameActionBody.create({
      url,
      buttonIndex,
      castId,
      state,
      inputText: inputText !== void 0 ? Buffer.from(inputText) : void 0,
      address,
      transactionId
    }),
    messageDataOptions,
    signer
  );
  if (message.isErr()) {
    return { message: null, trustedBytes: null };
  }
  const trustedBytes = Buffer.from(
    import_core.Message.encode(message._unsafeUnwrap()).finish()
  ).toString("hex");
  return { message: message.unwrapOr(null), trustedBytes };
}

// src/farcaster/signers.tsx
var mockFarcasterSigner = {
  fid: 1,
  status: "approved",
  publicKey: "0x00000000000000000000000000000000000000000000000000000000000000000",
  privateKey: "0x00000000000000000000000000000000000000000000000000000000000000000"
};

// src/index.tsx
var fallbackFrameContext = {
  castId: {
    fid: 1,
    hash: "0x0000000000000000000000000000000000000000"
  },
  connectedAddress: "0x0000000000000000000000000000000000000001"
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  FrameUI,
  createFrameActionMessageWithSignerKey,
  defaultTheme,
  fallbackFrameContext,
  mockFarcasterSigner,
  signFrameAction,
  themeParams
});
